var path = require('path');
var merge = require('deepmerge');

var _ = require('underscore');

_.mixin({
  /**
   * Capitilizes the string given and returns the string. Added as a test mixin.
   * @method _.capitalize
   * @param {String} string To capitalize
   * @returns {String} Returns capitalized string
   */
  capitalize: function(string) {
    
    return string.charAt(0).toUpperCase() + string.substring(1).toLowerCase();
  },

  /**
   * Returns the absolute path of the project root.
   * @method _.path
   * @returns {String} The absolute path of the project root
   */
  root: function (){
    return path.resolve(__dirname +"/../../");
  },
  /**
   * Merges two objects/and arrays deeply. It is an alias of deepmerge.
   * @method _.merge
   * @param {Object} x left object
   * @param {Object} y right object
   * @returns {Object}  Merged result.
   */
  merge : function (x,y){
    return merge(x,y);
  }
});

module.exports = _;
